scala.collection.mutable

# Stack

#### class Stack[A] extends Seq[A] with SeqLike[A, Stack[A]] with GenericTraversableTemplate[A, Stack] with Cloneable[Stack[A]] with Serializable

A stack implements a data structure which allows to store and retrieve objects in a last-in-first-out (LIFO) fashion.

A

  type of the elements contained in this stack.

Annotations
  @cloneable()
Source
  Stack.scala
Version

  2.8

Since

  1

See also

  Collection Library overview" section on `Stacks` for more information.

Linear Supertypes
Serializable, Serializable, Seq[A], SeqLike[A, Stack[A]], Cloneable[Stack[A]], Seq[A], SeqLike[A, Stack[A]], GenSeq[A], GenSeqLike[A, Stack[A]], PartialFunction[Int, A], (Int) ⇒ A, Iterable[A], Iterable[A], IterableLike[A, Stack[A]], Equals, GenIterable[A], GenIterableLike[A, Stack[A]], Traversable[A], Mutable, Traversable[A], GenTraversable[A], GenericTraversableTemplate[A, Stack], TraversableLike[A, Stack[A]], GenTraversableLike[A, Stack[A]], Parallelizable[A, ParSeq[A]], TraversableOnce[A], GenTraversableOnce[A], FilterMonadic[A, Stack[A]], HasNewBuilder[A, Stack[A]], AnyRef, Any
Known Subclasses
StackProxy, SynchronizedStack
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. Stack
2. Serializable
3. Serializable
4. Seq
5. SeqLike
6. Cloneable
7. Seq
8. SeqLike
9. GenSeq
10. GenSeqLike
11. PartialFunction
12. Function1
13. Iterable
14. Iterable
15. IterableLike
16. Equals
17. GenIterable
18. GenIterableLike
19. Traversable
20. Mutable
21. Traversable
22. GenTraversable
23. GenericTraversableTemplate
24. TraversableLike
25. GenTraversableLike
26. Parallelizable
27. TraversableOnce
28. GenTraversableOnce
29. FilterMonadic
30. HasNewBuilder
31. AnyRef
32. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new Stack()

### Type Members

1. #### type Self = Stack[A]

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected
   Definition Classes
     TraversableLike

2. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### abstract def ++[B](that: GenTraversableOnce[B]): Stack[B]

   [use case] Returns a new stack containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new stack containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the stack is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this stack followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

5. #### def ++[B >: A, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[Stack[A], B, That]): That

   Returns a new stack containing the elements from the left hand operand followed by the elements from the right hand operand.

   Returns a new stack containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the stack is the most specific superclass encompassing the element types of the two operands (see example).

   Example:

           scala> val a = LinkedList(1)
           a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

           scala> val b = LinkedList(2)
           b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val c = a ++ b
           c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

           scala> val d = LinkedList('a')
           d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

           scala> val e = c ++ d
           e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this stack followed by all elements of `that`.

   Definition Classes
     TraversableLike → GenTraversableLike

6. #### def ++:[B >: A, That](that: Traversable[B])(implicit bf: CanBuildFrom[Stack[A], B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand. It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new stack which contains all elements of this stack followed by all elements of `that`.

   Definition Classes
     TraversableLike

7. #### abstract def ++:[B](that: TraversableOnce[B]): Stack[B]

   [use case] Concatenates this stack with the elements of a traversable collection.

   [use case]

   Concatenates this stack with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this stack followed by all elements of `that`.

   Definition Classes
     TraversableLike

8. #### def ++:[B >: A, That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[Stack[A], B, That]): That

   Concatenates this stack with the elements of a traversable collection.

   Concatenates this stack with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this stack followed by all elements of `that`.

   Definition Classes
     TraversableLike

9. #### abstract def +:(elem: A): Stack[A]

   [use case] A copy of the stack with an element prepended.

   [use case]

   A copy of the stack with an element prepended.

   elem

     the prepended element

   returns

     a new collection of type `That` consisting of `elem` followed by all elements of this stack.

   Definition Classes
     GenSeqLike

10. #### def +:[B >: A, That](elem: B)(implicit bf: CanBuildFrom[Stack[A], B, That]): That

    A copy of the stack with an element prepended.

    A copy of the stack with an element prepended.

    Note that :-ending operators are right associative (see example). Also, the original stack is not modified, so you will want to capture the result.

    Example:

             scala> val x = LinkedList(1)
             x: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

             scala> val y = 2 +: x
             y: scala.collection.mutable.LinkedList[Int] = LinkedList(2, 1)

             scala> println(x)
             LinkedList(1)

    B

      the element type of the returned stack.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    elem

      the prepended element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` consisting of `elem` followed by all elements of this stack.

    Definition Classes
      SeqLike → GenSeqLike

11. #### def /:[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this stack, going left to right.

    Applies a binary operator to a start value and all elements of this stack, going left to right.

    Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (5 /: a)(_+_)
             b: Int = 15

             scala> val c = (5 /: a)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this stack, going left to right with the start value `z` on the left:

                      op(...op(op(z, x1), x2), ..., xn)

      where `x1, ..., xn` are the elements of this stack.

    Definition Classes
      TraversableOnce → GenTraversableOnce

12. #### def /:\[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    A syntactic sugar for out of order folding.

    A syntactic sugar for out of order folding. See `fold`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a /:\ 5)(_+_)
             b: Int = 15

    Definition Classes
      GenTraversableOnce

13. #### abstract def :+(elem: A): Stack[A]

    [use case] A copy of this stack with an element appended.

    [use case]

    A copy of this stack with an element appended.

    elem

      the appended element

    returns

      a new collection of type `That` consisting of all elements of this stack followed by `elem`.

    Definition Classes
      GenSeqLike

14. #### def :+[B >: A, That](elem: B)(implicit bf: CanBuildFrom[Stack[A], B, That]): That

    A copy of this stack with an element appended.

    A copy of this stack with an element appended.

    B

      the element type of the returned stack.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    elem

      the appended element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` consisting of all elements of this stack followed by `elem`.

    Definition Classes
      SeqLike → GenSeqLike

15. #### def :\[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this stack and a start value, going right to left.

    Applies a binary operator to all elements of this stack and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a :\ 5)(_+_)
             b: Int = 15

             scala> val c = (a :\ 5)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this stack, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this stack.

    Definition Classes
      TraversableOnce → GenTraversableOnce

16. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

17. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

18. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this stack to a string builder.

    Appends all elements of this stack to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this stack without any separator string.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> val h = a.addString(b)
             b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

19. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this stack to a string builder using a separator string.

    Appends all elements of this stack to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this stack, separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, ", ")
             res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

20. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all elements of this stack to a string builder using start, end, and separator strings.

    Appends all elements of this stack to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this stack are separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, "LinkedList(", ", ", ")")
             res1: StringBuilder = LinkedList(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

21. #### def aggregate[B](z: B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

22. #### def andThen[C](k: (A) ⇒ C): PartialFunction[Int, C]

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the same domain as this partial function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction → Function1

23. #### def apply(index: Int): A

    Retrieve n'th element from stack, where top of stack has index 0.

    Retrieve n'th element from stack, where top of stack has index 0.

    This is a linear time operation.

    index

      the index of the element to return

    returns

      the element at the specified index

    Definition Classes
      Stack → SeqLike → GenSeqLike → Function1
    Exceptions thrown
      IndexOutOfBoundsException

      if the index is out of bounds

24. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

25. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this stack should be compared

    returns

      `true`, if this stack can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

26. #### def clear(): Unit

    Removes all elements from the stack.

    Removes all elements from the stack. After this operation completed, the stack will be empty.

27. #### def clone(): Stack[A]

    This method clones the stack.

    This method clones the stack.

    returns

      a stack with the same elements.

    Definition Classes
      Stack → Cloneable → AnyRef

28. #### abstract def collect[B](pf: PartialFunction[A, B]): Stack[B]

    [use case] Builds a new collection by applying a partial function to all elements of this stack on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this stack on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the stack.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

29. #### def collect[B, That](pf: PartialFunction[A, B])(implicit bf: CanBuildFrom[Stack[A], B, That]): That

    Builds a new collection by applying a partial function to all elements of this stack on which the function is defined.

    Builds a new collection by applying a partial function to all elements of this stack on which the function is defined.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    pf

      the partial function which filters and maps the stack.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

30. #### def collectFirst[B](pf: PartialFunction[A, B]): Option[B]

    Finds the first element of the stack for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the stack for which the given partial function is defined, and applies the partial function to it.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

31. #### def combinations(n: Int): Iterator[Stack[A]]

    Iterates over combinations.

    Iterates over combinations.

    returns

      An Iterator which traverses the possible n-element combinations of this stack.

    Definition Classes
      SeqLike
    Example:

    1. `"abbbc".combinations(2) = Iterator(ab, ac, bb, bc)`

32. #### def companion: scala.collection.mutable.Stack.type

    The factory companion object that builds instances of class Stack.

    The factory companion object that builds instances of class Stack. (or its `Iterable` superclass where class Stack is not a `Seq`.)

    Definition Classes
      Stack → Seq → Seq → GenSeq → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → GenericTraversableTemplate

33. #### def compose[A](g: (A) ⇒ Int): (A) ⇒ A

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1

34. #### def contains(elem: Any): Boolean

    Tests whether this stack contains a given value as an element.

    Tests whether this stack contains a given value as an element.

    elem

      the element to test.

    returns

      `true` if this stack has an element that is is equal (wrt `==`) to `elem`, `false` otherwise.

    Definition Classes
      SeqLike

35. #### def containsSlice[B](that: GenSeq[B]): Boolean

    Tests whether this stack contains a given sequence as a slice.

    Tests whether this stack contains a given sequence as a slice.

    that

      the sequence to test

    returns

      `true` if this stack contains a slice with the same elements as `that`, otherwise `false`.

    Definition Classes
      SeqLike

36. #### abstract def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies elements of this stack to an array.

    [use case]

    Copies elements of this stack to an array. Fills the given array `xs` with at most `len` elements of this stack, starting at position `start`. Copying will stop once either the end of the current stack is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      TraversableLike

37. #### def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

    Copies elements of this stack to an array.

    Copies elements of this stack to an array. Fills the given array `xs` with at most `len` elements of this stack, starting at position `start`. Copying will stop once either the end of the current stack is reached, or the end of the array is reached, or `len` elements have been copied.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

38. #### abstract def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this stack to an array.

    [use case]

    Copies values of this stack to an array. Fills the given array `xs` with values of this stack. Copying will stop once either the end of the current stack is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

39. #### def copyToArray[B >: A](xs: Array[B]): Unit

    Copies values of this stack to an array.

    Copies values of this stack to an array. Fills the given array `xs` with values of this stack. Copying will stop once either the end of the current stack is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce

40. #### abstract def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this stack to an array.

    [use case]

    Copies values of this stack to an array. Fills the given array `xs` with values of this stack, beginning at index `start`. Copying will stop once either the end of the current stack is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

41. #### def copyToArray[B >: A](xs: Array[B], start: Int): Unit

    Copies values of this stack to an array.

    Copies values of this stack to an array. Fills the given array `xs` with values of this stack, beginning at index `start`. Copying will stop once either the end of the current stack is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce

42. #### def copyToBuffer[B >: A](dest: Buffer[B]): Unit

    Copies all elements of this stack to a buffer.

    Copies all elements of this stack to a buffer.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

43. #### def corresponds[B](that: GenSeq[B])(p: (A, B) ⇒ Boolean): Boolean

    Tests whether every element of this stack relates to the corresponding element of another sequence by satisfying a test predicate.

    Tests whether every element of this stack relates to the corresponding element of another sequence by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this stack and `y` of `that`, otherwise `false`.

    Definition Classes
      SeqLike → GenSeqLike

44. #### def count(p: (A) ⇒ Boolean): Int

    Counts the number of elements in the stack which satisfy a predicate.

    Counts the number of elements in the stack which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

45. #### abstract def diff(that: Seq[A]): Stack[A]

    [use case] Computes the multiset difference between this stack and another sequence.

    [use case]

    Computes the multiset difference between this stack and another sequence.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this stack except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike

46. #### def diff[B >: A](that: GenSeq[B]): Stack[A]

    Computes the multiset difference between this stack and another sequence.

    Computes the multiset difference between this stack and another sequence.

    B

      the element type of the returned stack.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this stack except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike → GenSeqLike

47. #### def distinct: Stack[A]

    Builds a new stack from this stack without any duplicate elements.

    Builds a new stack from this stack without any duplicate elements.

    returns

      A new stack which contains the first occurrence of every element of this stack.

    Definition Classes
      SeqLike → GenSeqLike

48. #### def drop(n: Int): Stack[A]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    n

      the number of elements to drop from this stack.

    returns

      a stack consisting of all elements of this stack except the first `n` ones, or else the empty stack, if this stack has less than `n` elements.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike

49. #### def dropRight(n: Int): Stack[A]

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    n

      The number of elements to take

    returns

      a stack consisting of all elements of this stack except the last `n` ones, or else the empty stack, if this stack has less than `n` elements.

    Definition Classes
      IterableLike

50. #### def dropWhile(p: (A) ⇒ Boolean): Stack[A]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    p

      The predicate used to test elements.

    returns

      the longest suffix of this stack whose first element does not satisfy the predicate `p`.

    Definition Classes
      TraversableLike → GenTraversableLike

51. #### var elems: List[A]

52. #### def endsWith[B](that: GenSeq[B]): Boolean

    Tests whether this stack ends with the given sequence.

    Tests whether this stack ends with the given sequence.

    that

      the sequence to test

    returns

      `true` if this stack has `that` as a suffix, `false` otherwise.

    Definition Classes
      SeqLike → GenSeqLike

53. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

54. #### def equals(that: Any): Boolean

    The equals method for arbitrary sequences.

    The equals method for arbitrary sequences. Compares this sequence to some other object.

    that

      The object to compare the sequence to

    returns

      `true` if `that` is a sequence that has the same elements as this sequence in the same order, `false` otherwise

    Definition Classes
      GenSeqLike → Equals → AnyRef → Any

55. #### def exists(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this stack.

    Tests whether a predicate holds for some of the elements of this stack.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this stack, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

56. #### def filter(p: (A) ⇒ Boolean): Stack[A]

    Selects all elements of this stack which satisfy a predicate.

    Selects all elements of this stack which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new stack consisting of all elements of this stack that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

57. #### def filterNot(p: (A) ⇒ Boolean): Stack[A]

    Selects all elements of this stack which do not satisfy a predicate.

    Selects all elements of this stack which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new stack consisting of all elements of this stack that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

58. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

59. #### def find(p: (A) ⇒ Boolean): Option[A]

    Finds the first element of the stack satisfying a predicate, if any.

    Finds the first element of the stack satisfying a predicate, if any.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the stack that satisfies `p`, or `None` if none exists.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

60. #### abstract def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): Stack[B]

    [use case] Builds a new collection by applying a function to all elements of this stack and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this stack and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this stack and concatenating the results.

    Definition Classes
      GenTraversableLike

61. #### def flatMap[B, That](f: (A) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[Stack[A], B, That]): That

    Builds a new collection by applying a function to all elements of this stack and using the elements of the resulting collections.

    Builds a new collection by applying a function to all elements of this stack and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of stack. This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this stack and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic

62. #### abstract def flatten[B]: Stack[B]

    [use case] Converts this stack of traversable collections into a stack formed by the elements of these traversable collections.

    [use case]

    Converts this stack of traversable collections into a stack formed by the elements of these traversable collections.

    B

      the type of the elements of each traversable collection.

    returns

      a new stack resulting from concatenating all element stacks.

    Definition Classes
      GenericTraversableTemplate

63. #### def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this stack using the specified associative binary operator.

    Folds the elements of this stack using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

64. #### def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this stack, going left to right.

    Applies a binary operator to a start value and all elements of this stack, going left to right.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this stack, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this stack.

    Definition Classes
      TraversableOnce → GenTraversableOnce

65. #### def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this stack and a start value, going right to left.

    Applies a binary operator to all elements of this stack and a start value, going right to left.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this stack, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this stack.

    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce

66. #### def forall(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this stack.

    Tests whether a predicate holds for all elements of this stack.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this stack, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

67. #### abstract def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this stack.

    [use case]

    Applies a function `f` to all elements of this stack.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike

68. #### def foreach[U](f: (A) ⇒ U): Unit

    Applies a function `f` to all elements of this stack.

    Applies a function `f` to all elements of this stack.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    U

      the type parameter describing the result of function `f`. This result will always be ignored. Typically `U` is `Unit`, but this is not necessary.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      Stack → IterableLike → GenericTraversableTemplate → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `foreach` traverses in FIFO order.

69. #### def genericBuilder[B]: Builder[B, Stack[B]]

    The generic builder that builds instances of Stack at arbitrary element types.

    The generic builder that builds instances of Stack at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

70. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

71. #### def groupBy[K](f: (A) ⇒ K): Map[K, Stack[A]]

    Partitions this stack into a map of stacks according to some discriminator function.

    Partitions this stack into a map of stacks according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new stack.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to stacks such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a stack of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

72. #### def grouped(size: Int): Iterator[Stack[A]]

    Partitions elements in fixed size stacks.

    Partitions elements in fixed size stacks.

    size

      the number of elements per group

    returns

      An iterator producing stacks of size `size`, except the last will be truncated if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      Iterator#grouped

73. #### def hasDefiniteSize: Boolean

    Tests whether this stack is known to have a finite size.

    Tests whether this stack is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

74. #### def hashCode(): Int

    Hashcodes for Stack produce a value from the hashcodes of all the elements of the stack.

    Hashcodes for Stack produce a value from the hashcodes of all the elements of the stack.

    returns

      the hash code value for this object.

    Definition Classes
      GenSeqLike → AnyRef → Any

75. #### def head: A

    Selects the first element of this stack.

    Selects the first element of this stack.

    returns

      the first element of this stack.

    Definition Classes
      IterableLike → GenIterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the stack is empty.

76. #### def headOption: Option[A]

    Optionally selects the first element.

    Optionally selects the first element.

    returns

      the first element of this stack if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

77. #### abstract def indexOf(elem: A, from: Int): Int

    [use case] Finds index of first occurrence of some value in this stack after or at some start index.

    [use case]

    Finds index of first occurrence of some value in this stack after or at some start index.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

78. #### def indexOf[B >: A](elem: B, from: Int): Int

    Finds index of first occurrence of some value in this stack after or at some start index.

    Finds index of first occurrence of some value in this stack after or at some start index.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

79. #### abstract def indexOf(elem: A): Int

    [use case] Finds index of first occurrence of some value in this stack.

    [use case]

    Finds index of first occurrence of some value in this stack.

    elem

      the element value to search for.

    returns

      the index of the first element of this stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

80. #### def indexOf[B >: A](elem: B): Int

    Finds index of first occurrence of some value in this stack.

    Finds index of first occurrence of some value in this stack.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    returns

      the index of the first element of this stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

81. #### def indexOfSlice[B >: A](that: GenSeq[B], from: Int): Int

    Finds first index after or at a start index where this stack contains a given sequence as a slice.

    Finds first index after or at a start index where this stack contains a given sequence as a slice.

    that

      the sequence to test

    from

      the start index

    returns

      the first index `>= from` such that the elements of this stack starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

82. #### def indexOfSlice[B >: A](that: GenSeq[B]): Int

    Finds first index where this stack contains a given sequence as a slice.

    Finds first index where this stack contains a given sequence as a slice.

    that

      the sequence to test

    returns

      the first index such that the elements of this stack starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

83. #### def indexWhere(p: (A) ⇒ Boolean, from: Int): Int

    Finds index of the first element satisfying some predicate after or at some start index.

    Finds index of the first element satisfying some predicate after or at some start index.

    p

      the predicate used to test elements.

    from

      the start index

    returns

      the index `>= from` of the first element of this stack that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      SeqLike → GenSeqLike

84. #### def indexWhere(p: (A) ⇒ Boolean): Int

    Finds index of first element satisfying some predicate.

    Finds index of first element satisfying some predicate.

    p

      the predicate used to test elements.

    returns

      the index of the first element of this stack that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

85. #### def indices: Range

    Produces the range of all indices of this sequence.

    Produces the range of all indices of this sequence.

    returns

      a `Range` value from `0` to one less than the length of this stack.

    Definition Classes
      SeqLike

86. #### def init: Stack[A]

    Selects all elements except the last.

    Selects all elements except the last.

    returns

      a stack consisting of all elements of this stack except the last one.

    Definition Classes
      TraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the stack is empty.

87. #### def inits: Iterator[Stack[A]]

    Iterates over the inits of this stack.

    Iterates over the inits of this stack. The first value will be this stack and the final one will be an empty stack, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this stack

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

88. #### abstract def intersect(that: Seq[A]): Stack[A]

    [use case] Computes the multiset intersection between this stack and another sequence.

    [use case]

    Computes the multiset intersection between this stack and another sequence.

    that

      the sequence of elements to intersect with.

    returns

      a new collection of type `That` which contains all elements of this stack which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      SeqLike

89. #### def intersect[B >: A](that: GenSeq[B]): Stack[A]

    Computes the multiset intersection between this stack and another sequence.

    Computes the multiset intersection between this stack and another sequence.

    B

      the element type of the returned stack.

    that

      the sequence of elements to intersect with.

    returns

      a new collection of type `That` which contains all elements of this stack which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      SeqLike → GenSeqLike

90. #### def isDefinedAt(idx: Int): Boolean

    Tests whether this stack contains given index.

    Tests whether this stack contains given index.

    The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

    idx

      the index to test

    returns

      `true` if this stack contains an element at position `idx`, `false` otherwise.

    Definition Classes
      GenSeqLike

91. #### def isEmpty: Boolean

    Checks if the stack is empty.

    Checks if the stack is empty.

    returns

      true, iff there is no element on the stack

    Definition Classes
      Stack → IterableLike → GenIterableLike → GenericTraversableTemplate → TraversableLike → TraversableOnce → GenTraversableOnce

92. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

93. #### final def isTraversableAgain: Boolean

    Tests whether this stack can be repeatedly traversed.

    Tests whether this stack can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      GenTraversableLike → GenTraversableOnce

94. #### def iterator: Iterator[A]

    Returns an iterator over all elements on the stack.

    Returns an iterator over all elements on the stack. This iterator is stable with respect to state changes in the stack object; i.e. such changes will not be reflected in the iterator. The iterator issues elements in the reversed order they were inserted into the stack (LIFO order).

    returns

      an iterator over all stack elements.

    Definition Classes
      Stack → IterableLike → GenIterableLike
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `iterator` traverses in FIFO order.

95. #### def last: A

    Selects the last element.

    Selects the last element.

    returns

      The last element of this stack.

    Definition Classes
      TraversableLike
    Exceptions thrown
      NoSuchElementException

      If the stack is empty.

96. #### abstract def lastIndexOf(elem: A, end: Int): Int

    [use case] Finds index of last occurrence of some value in this stack before or at a given end index.

    [use case]

    Finds index of last occurrence of some value in this stack before or at a given end index.

    elem

      the element value to search for.

    end

      the end index.

    returns

      the index `<= end` of the last element of this stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

97. #### def lastIndexOf[B >: A](elem: B, end: Int): Int

    Finds index of last occurrence of some value in this stack before or at a given end index.

    Finds index of last occurrence of some value in this stack before or at a given end index.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    end

      the end index.

    returns

      the index `<= end` of the last element of this stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

98. #### abstract def lastIndexOf(elem: A): Int

    [use case] Finds index of last occurrence of some value in this stack.

    [use case]

    Finds index of last occurrence of some value in this stack.

    elem

      the element value to search for.

    returns

      the index of the last element of this stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

99. #### def lastIndexOf[B >: A](elem: B): Int

    Finds index of last occurrence of some value in this stack.

    Finds index of last occurrence of some value in this stack.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    returns

      the index of the last element of this stack that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

100. #### def lastIndexOfSlice[B >: A](that: GenSeq[B], end: Int): Int

     Finds last index before or at a given end index where this stack contains a given sequence as a slice.

     Finds last index before or at a given end index where this stack contains a given sequence as a slice.

     that

       the sequence to test

     end

       the end index

     returns

       the last index `<= end` such that the elements of this stack starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

     Definition Classes
       SeqLike

101. #### def lastIndexOfSlice[B >: A](that: GenSeq[B]): Int

     Finds last index where this stack contains a given sequence as a slice.

     Finds last index where this stack contains a given sequence as a slice.

     that

       the sequence to test

     returns

       the last index such that the elements of this stack starting a this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

     Definition Classes
       SeqLike

102. #### def lastIndexWhere(p: (A) ⇒ Boolean, end: Int): Int

     Finds index of last element satisfying some predicate before or at given end index.

     Finds index of last element satisfying some predicate before or at given end index.

     p

       the predicate used to test elements.

     returns

       the index `<= end` of the last element of this stack that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       SeqLike → GenSeqLike

103. #### def lastIndexWhere(p: (A) ⇒ Boolean): Int

     Finds index of last element satisfying some predicate.

     Finds index of last element satisfying some predicate.

     p

       the predicate used to test elements.

     returns

       the index of the last element of this stack that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

104. #### def lastOption: Option[A]

     Optionally selects the last element.

     Optionally selects the last element.

     returns

       the last element of this stack$ if it is nonempty, `None` if it is empty.

     Definition Classes
       TraversableLike

105. #### def length: Int

     The number of elements in the stack

     The number of elements in the stack

     returns

       the number of elements in this stack.

     Definition Classes
       Stack → SeqLike → GenSeqLike

106. #### def lengthCompare(len: Int): Int

     Compares the length of this stack to a test value.

     Compares the length of this stack to a test value.

     len

       the test value that gets compared with the length.

     returns

       A value `x` where

                  x <  0       if this.length <  len
                  x == 0       if this.length == len
                  x >  0       if this.length >  len

       The method as implemented here does not call `length` directly; its running time is `O(length min len)` instead of `O(length)`. The method should be overwritten if computing `length` is cheap.

     Definition Classes
       SeqLike

107. #### def lift: (Int) ⇒ Option[A]

     Turns this partial function into an plain function returning an `Option` result.

     Turns this partial function into an plain function returning an `Option` result.

     returns

       a function that takes an argument `x` to `Some(this(x))` if `this` is defined for `x`, and to `None` otherwise.

     Definition Classes
       PartialFunction
     See also

       Function.unlift

108. #### abstract def map[B](f: (A) ⇒ B): Stack[B]

     [use case] Builds a new collection by applying a function to all elements of this stack.

     [use case]

     Builds a new collection by applying a function to all elements of this stack.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this stack and collecting the results.

     Definition Classes
       GenTraversableLike

109. #### def map[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[Stack[A], B, That]): That

     Builds a new collection by applying a function to all elements of this stack.

     Builds a new collection by applying a function to all elements of this stack.

     B

       the element type of the returned collection.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     f

       the function to apply to each element.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this stack and collecting the results.

     Definition Classes
       TraversableLike → GenTraversableLike → FilterMonadic

110. #### abstract def max: A

     [use case] Finds the largest element.

     [use case]

     Finds the largest element.

     returns

       the largest element of this stack with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

111. #### def max[B >: A](implicit cmp: Ordering[B]): A

     Finds the largest element.

     Finds the largest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the largest element of this stack with respect to the ordering `cmp`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

112. #### def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

     Definition Classes
       TraversableOnce → GenTraversableOnce

113. #### abstract def min: A

     [use case] Finds the smallest element.

     [use case]

     Finds the smallest element.

     returns

       the smallest element of this stack with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

114. #### def min[B >: A](implicit cmp: Ordering[B]): A

     Finds the smallest element.

     Finds the smallest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the smallest element of this stack with respect to the ordering `cmp`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

115. #### def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

     Definition Classes
       TraversableOnce → GenTraversableOnce

116. #### def mkString: String

     Displays all elements of this stack in a string.

     Displays all elements of this stack in a string.

     returns

       a string representation of this stack. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this stack follow each other without any separator string.

     Definition Classes
       TraversableOnce → GenTraversableOnce

117. #### def mkString(sep: String): String

     Displays all elements of this stack in a string using a separator string.

     Displays all elements of this stack in a string using a separator string.

     sep

       the separator string.

     returns

       a string representation of this stack. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this stack are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("|") = "1|2|3"`

118. #### def mkString(start: String, sep: String, end: String): String

     Displays all elements of this stack in a string using start, end, and separator strings.

     Displays all elements of this stack in a string using start, end, and separator strings.

     start

       the starting string.

     sep

       the separator string.

     end

       the ending string.

     returns

       a string representation of this stack. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this stack are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

119. #### final def ne(arg0: AnyRef): Boolean

     Equivalent to `!(this eq that)`.

     Equivalent to `!(this eq that)`.

     returns

       `true` if the argument is not a reference to the receiver object; `false` otherwise.

     Definition Classes
       AnyRef

120. #### def newBuilder: Builder[A, Stack[A]]

     The builder that builds instances of type Stack[A]

     The builder that builds instances of type Stack[A]

     Attributes
       protected[this]
     Definition Classes
       GenericTraversableTemplate → HasNewBuilder

121. #### def nonEmpty: Boolean

     Tests whether the stack is not empty.

     Tests whether the stack is not empty.

     returns

       `true` if the stack contains at least one element, `false` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

122. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

123. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

124. #### def orElse[A1 <: Int, B1 >: A](that: PartialFunction[A1, B1]): PartialFunction[A1, B1]

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     A1

       the argument type of the fallback function

     B1

       the result type of the fallback function

     that

       the fallback function

     returns

       a partial function which has as domain the union of the domains of this partial function and `that`. The resulting partial function takes `x` to `this(x)` where `this` is defined, and to `that(x)` where it is not.

     Definition Classes
       PartialFunction

125. #### abstract def padTo(len: Int, elem: A): Stack[A]

     [use case] A copy of this stack with an element value appended until a given target length is reached.

     [use case]

     A copy of this stack with an element value appended until a given target length is reached.

     len

       the target length

     elem

       the padding value

     returns

       a new collection of type `That` consisting of all elements of this stack followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       GenSeqLike

126. #### def padTo[B >: A, That](len: Int, elem: B)(implicit bf: CanBuildFrom[Stack[A], B, That]): That

     A copy of this stack with an element value appended until a given target length is reached.

     A copy of this stack with an element value appended until a given target length is reached.

     B

       the element type of the returned stack.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     len

       the target length

     elem

       the padding value

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` consisting of all elements of this stack followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       SeqLike → GenSeqLike

127. #### def par: ParSeq[A]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       Parallelizable

128. #### def parCombiner: Combiner[A, ParSeq[A]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       SeqLike → SeqLike → TraversableLike → Parallelizable

129. #### def partition(p: (A) ⇒ Boolean): (Stack[A], Stack[A])

     Partitions this stack in two stacks according to a predicate.

     Partitions this stack in two stacks according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of stacks: the first stack consists of all elements that satisfy the predicate `p` and the second stack consists of all elements that don't. The relative order of the elements in the resulting stacks is the same as in the original stack.

     Definition Classes
       TraversableLike → GenTraversableLike

130. #### abstract def patch(from: Int, that: GenSeq[A], replaced: Int): Stack[A]

     [use case] Produces a new stack where a slice of elements in this stack is replaced by another sequence.

     [use case]

     Produces a new stack where a slice of elements in this stack is replaced by another sequence.

     from

       the index of the first replaced element

     replaced

       the number of elements to drop in the original stack

     returns

       a new stack consisting of all elements of this stack except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       GenSeqLike

131. #### def patch[B >: A, That](from: Int, patch: GenSeq[B], replaced: Int)(implicit bf: CanBuildFrom[Stack[A], B, That]): That

     Produces a new stack where a slice of elements in this stack is replaced by another sequence.

     Produces a new stack where a slice of elements in this stack is replaced by another sequence.

     B

       the element type of the returned stack.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     from

       the index of the first replaced element

     patch

       the replacement sequence

     replaced

       the number of elements to drop in the original stack

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new stack consisting of all elements of this stack except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       SeqLike → GenSeqLike

132. #### def permutations: Iterator[Stack[A]]

     Iterates over distinct permutations.

     Iterates over distinct permutations.

     returns

       An Iterator which traverses the distinct permutations of this stack.

     Definition Classes
       SeqLike
     Example:

     1. `"abb".permutations = Iterator(abb, bab, bba)`

133. #### def pop(): A

     Removes the top element from the stack.

     Removes the top element from the stack.

     returns

       the top element

     Exceptions thrown
       Predef.NoSuchElementException

134. #### def prefixLength(p: (A) ⇒ Boolean): Int

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     returns

       the length of the longest prefix of this stack such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       GenSeqLike

135. #### abstract def product: A

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements of this stack with respect to the `*` operator in `num`.

     Definition Classes
       GenTraversableOnce

136. #### def product[B >: A](implicit num: Numeric[B]): B

     Multiplies up the elements of this collection.

     Multiplies up the elements of this collection.

     B

       the result type of the `*` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

     returns

       the product of all elements of this stack with respect to the `*` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

137. #### def push(elem1: A, elem2: A, elems: A*): Stack.this.type

     Push two or more elements onto the stack.

     Push two or more elements onto the stack. The last element of the sequence will be on top of the new stack.

     elems

       the element sequence.

     returns

       the stack with the new elements on top.

138. #### def push(elem: A): Stack.this.type

     Push an element on the stack.

     Push an element on the stack.

     elem

       the element to push on the stack.

     returns

       the stack with the new element on top.

139. #### def pushAll(xs: TraversableOnce[A]): Stack.this.type

     Push all elements in the given traversable object onto the stack.

     Push all elements in the given traversable object onto the stack. The last element in the traversable object will be on top of the new stack.

     xs

       the traversable object.

     returns

       the stack with the new elements on top.

140. #### def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this stack using the specified associative binary operator.

     Reduces the elements of this stack using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the stack is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this stack is empty.

141. #### def reduceLeft[B >: A](op: (B, A) ⇒ B): B

     Definition Classes
       TraversableOnce

142. #### def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this stack, going left to right.

     Optionally applies a binary operator to all elements of this stack, going left to right.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this stack is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

143. #### def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this stack, if any, using the specified associative binary operator.

     Reduces the elements of this stack, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

144. #### def reduceRight[B >: A](op: (A, B) ⇒ B): B

     Applies a binary operator to all elements of this stack, going right to left.

     Applies a binary operator to all elements of this stack, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this stack, going right to left:

                       op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

       where `x1, ..., xn` are the elements of this stack.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this stack is empty.

145. #### def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this stack, going right to left.

     Optionally applies a binary operator to all elements of this stack, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this stack is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

146. #### def repr: Stack[A]

     The collection of type stack underlying this `TraversableLike` object.

     The collection of type stack underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

147. #### def reverse: Stack[A]

     Returns new stack wih elements in reversed order.

     Returns new stack wih elements in reversed order.

     returns

       A new stack with all elements of this stack in reversed order.

     Definition Classes
       SeqLike → GenSeqLike

148. #### def reverseIterator: Iterator[A]

     An iterator yielding elements in reversed order.

     An iterator yielding elements in reversed order.

     Note: `xs.reverseIterator` is the same as `xs.reverse.iterator` but might be more efficient.

     returns

       an iterator yielding the elements of this stack in reversed order

     Definition Classes
       SeqLike

149. #### abstract def reverseMap[B](f: (A) ⇒ B): Stack[B]

     [use case] Builds a new collection by applying a function to all elements of this stack and collecting the results in reversed order.

     [use case]

     Builds a new collection by applying a function to all elements of this stack and collecting the results in reversed order.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this stack and collecting the results in reversed order.

       Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     Definition Classes
       GenSeqLike

150. #### def reverseMap[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[Stack[A], B, That]): That

     Builds a new collection by applying a function to all elements of this stack and collecting the results in reversed order.

     Builds a new collection by applying a function to all elements of this stack and collecting the results in reversed order.

     Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     B

       the element type of the returned collection.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     f

       the function to apply to each element.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this stack and collecting the results in reversed order.

     Definition Classes
       SeqLike → GenSeqLike

151. #### def reversed: List[A]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

152. #### abstract def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this stack.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this stack.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       GenIterableLike

153. #### def sameElements[B >: A](that: GenIterable[B]): Boolean

     Checks if the other iterable collection contains the same elements in the same order as this stack.

     Checks if the other iterable collection contains the same elements in the same order as this stack.

     B

       the type of the elements of collection `that`.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IterableLike → GenIterableLike

154. #### def scan[B >: A, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[Stack[A], B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new stack containing the prefix scan of the elements in this stack

     Definition Classes
       TraversableLike → GenTraversableLike

155. #### def scanLeft[B, That](z: B)(op: (B, A) ⇒ B)(implicit bf: CanBuildFrom[Stack[A], B, That]): That

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

156. #### def scanRight[B, That](z: B)(op: (A, B) ⇒ B)(implicit bf: CanBuildFrom[Stack[A], B, That]): That

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Example:

            List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

157. #### def segmentLength(p: (A) ⇒ Boolean, from: Int): Int

     Computes length of longest segment whose elements all satisfy some predicate.

     Computes length of longest segment whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     from

       the index where the search starts.

     returns

       the length of the longest segment of this stack starting from index `from` such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       SeqLike → GenSeqLike

158. #### def seq: Seq[A]

     A version of this collection with all of the operations implemented sequentially (i.

     A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       Seq → Seq → GenSeq → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

159. #### def size: Int

     The size of this stack, equivalent to `length`.

     The size of this stack, equivalent to `length`.

     returns

       the number of elements in this stack.

     Definition Classes
       SeqLike → GenTraversableLike → TraversableOnce → GenTraversableOnce

160. #### def slice(from: Int, until: Int): Stack[A]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

            from <= indexOf(x) < until

     from

       the lowest index to include from this stack.

     until

       the highest index to EXCLUDE from this stack.

     returns

       a stack containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this stack.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

161. #### def sliding[B >: A](size: Int, step: Int): Iterator[Stack[A]]

     Definition Classes
       IterableLike

162. #### def sliding[B >: A](size: Int): Iterator[Stack[A]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     returns

       An iterator producing stacks of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       Iterator#sliding

163. #### def sortBy[B](f: (A) ⇒ B)(implicit ord: Ordering[B]): Stack[A]

     Sorts this Stack according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     Sorts this Stack according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     B

       the target type of the transformation `f`, and the type where the ordering `ord` is defined.

     f

       the transformation function mapping elements to some other domain `B`.

     ord

       the ordering assumed on domain `B`.

     returns

       a stack consisting of the elements of this stack sorted according to the ordering where `x < y` if `ord.lt(f(x), f(y))`.

     Definition Classes
       SeqLike
     Example:

     1.        val words = "The quick brown fox jumped over the lazy dog".split(' ')
               // this works because scala.Ordering will implicitly provide an Ordering[Tuple2[Int, Char]]
               words.sortBy(x => (x.length, x.head))
               res0: Array[String] = Array(The, dog, fox, the, lazy, over, brown, quick, jumped)

     See also

       scala.math.Ordering

164. #### def sortWith(lt: (A, A) ⇒ Boolean): Stack[A]

     Sorts this stack according to a comparison function.

     Sorts this stack according to a comparison function.

     The sort is stable. That is, elements that are equal wrt `lt` appear in the same order in the sorted sequence as in the original.

     lt

       the comparison function which tests whether its first argument precedes its second argument in the desired ordering.

     returns

       a stack consisting of the elements of this stack sorted according to the comparison function `lt`.

     Definition Classes
       SeqLike
     Example:

     1.        List("Steve", "Tom", "John", "Bob").sortWith(_.compareTo(_) < 0) =
               List("Bob", "John", "Steve", "Tom")

165. #### def sorted[B >: A](implicit ord: Ordering[B]): Stack[A]

     Sorts this stack according to an Ordering.

     Sorts this stack according to an Ordering.

     The sort is stable. That is, elements that are equal wrt `lt` appear in the same order in the sorted sequence as in the original.

     ord

       the ordering to be used to compare elements.

     returns

       a stack consisting of the elements of this stack sorted according to the ordering `ord`.

     Definition Classes
       SeqLike
     See also

       scala.math.Ordering

166. #### def span(p: (A) ⇒ Boolean): (Stack[A], Stack[A])

     Splits this stack into a prefix/suffix pair according to a predicate.

     Splits this stack into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     p

       the test predicate

     returns

       a pair consisting of the longest prefix of this stack whose elements all satisfy `p`, and the rest of this stack.

     Definition Classes
       TraversableLike → GenTraversableLike

167. #### def splitAt(n: Int): (Stack[A], Stack[A])

     Splits this stack into two at a given position.

     Splits this stack into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     n

       the position at which to split.

     returns

       a pair of stacks consisting of the first `n` elements of this stack, and the other elements.

     Definition Classes
       TraversableLike → GenTraversableLike

168. #### def startsWith[B](that: GenSeq[B], offset: Int): Boolean

     Tests whether this stack contains the given sequence at a given index.

     Tests whether this stack contains the given sequence at a given index.

     If the both the receiver object, `this` and the argument, `that` are infinite sequences this method may not terminate.

     that

       the sequence to test

     offset

       the index where the sequence is searched.

     returns

       `true` if the sequence `that` is contained in this stack at index `offset`, otherwise `false`.

     Definition Classes
       SeqLike → GenSeqLike

169. #### def startsWith[B](that: GenSeq[B]): Boolean

     Tests whether this stack starts with the given sequence.

     Tests whether this stack starts with the given sequence.

     that

       the sequence to test

     returns

       `true` if this collection has `that` as a prefix, `false` otherwise.

     Definition Classes
       GenSeqLike

170. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this stack. By default the string prefix is the simple name of the collection class stack.

     Definition Classes
       TraversableLike → GenTraversableLike

171. #### abstract def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements of this stack with respect to the `+` operator in `num`.

     Definition Classes
       GenTraversableOnce

172. #### def sum[B >: A](implicit num: Numeric[B]): B

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     B

       the result type of the `+` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this stack with respect to the `+` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

173. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

174. #### def tail: Stack[A]

     Selects all elements except the first.

     Selects all elements except the first.

     returns

       a stack consisting of all elements of this stack except the first one.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the stack is empty.

175. #### def tails: Iterator[Stack[A]]

     Iterates over the tails of this stack.

     Iterates over the tails of this stack. The first value will be this stack and the final one will be an empty stack, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this stack

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

176. #### def take(n: Int): Stack[A]

     Selects first n elements.

     Selects first n elements.

     n

       Tt number of elements to take from this stack.

     returns

       a stack consisting only of the first `n` elements of this stack, or else the whole stack, if it has less than `n` elements.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

177. #### def takeRight(n: Int): Stack[A]

     Selects last n elements.

     Selects last n elements.

     n

       the number of elements to take

     returns

       a stack consisting only of the last `n` elements of this stack, or else the whole stack, if it has less than `n` elements.

     Definition Classes
       IterableLike

178. #### def takeWhile(p: (A) ⇒ Boolean): Stack[A]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     p

       The predicate used to test elements.

     returns

       the longest prefix of this stack whose elements all satisfy the predicate `p`.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

179. #### def thisCollection: Seq[A]

     The underlying collection seen as an instance of `Stack`.

     The underlying collection seen as an instance of `Stack`. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       SeqLike → IterableLike → TraversableLike

180. #### abstract def toArray: Array[A]

     [use case] Converts this stack to an array.

     [use case]

     Converts this stack to an array.

     returns

       an array containing all elements of this stack.

     Definition Classes
       GenTraversableOnce

181. #### def toArray[B >: A](implicit arg0: ClassManifest[B]): Array[B]

     Converts this stack to an array.

     Converts this stack to an array.

     B

       the type of the elements of the array. A `ClassManifest` for this type must be available.

     returns

       an array containing all elements of this stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

182. #### def toBuffer[B >: A]: Buffer[B]

     Converts this stack to a mutable buffer.

     Converts this stack to a mutable buffer.

     returns

       a buffer containing all elements of this stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

183. #### def toCollection(repr: Stack[A]): Seq[A]

     A conversion from collections of type `Repr` to `Stack` objects.

     A conversion from collections of type `Repr` to `Stack` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       SeqLike → IterableLike → TraversableLike

184. #### def toIndexedSeq[B >: A]: IndexedSeq[B]

     Converts this stack to an indexed sequence.

     Converts this stack to an indexed sequence.

     returns

       an indexed sequence containing all elements of this stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

185. #### def toIterable: Iterable[A]

     Converts this stack to an iterable collection.

     Converts this stack to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     returns

       an `Iterable` containing all elements of this stack.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

186. #### def toIterator: Iterator[A]

     Returns an Iterator over the elements in this stack.

     Returns an Iterator over the elements in this stack. Will return the same Iterator if this instance is already an Iterator.

     returns

       an Iterator containing all elements of this stack.

     Definition Classes
       TraversableLike → GenTraversableOnce

187. #### def toList: List[A]

     Creates a list of all stack elements in LIFO order.

     Creates a list of all stack elements in LIFO order.

     returns

       the created list.

     Definition Classes
       Stack → TraversableOnce → GenTraversableOnce
     Annotations
       @migration
     Migration

       (Changed in version 2.8.0) `toList` traverses in FIFO order.

188. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this stack to a map.

     [use case]

     Converts this stack to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this stack.

     Definition Classes
       GenTraversableOnce

189. #### def toMap[T, U](implicit ev: <:<[A, (T, U)]): Map[T, U]

     Converts this stack to a map.

     Converts this stack to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

190. #### def toSeq: Seq[A]

     Converts this stack to a sequence.

     Converts this stack to a sequence.

     Overridden for efficiency.

     returns

       a sequence containing all elements of this stack.

     Definition Classes
       SeqLike → GenSeqLike → TraversableOnce → GenTraversableOnce

191. #### def toSet[B >: A]: Set[B]

     Converts this stack to a set.

     Converts this stack to a set.

     returns

       a set containing all elements of this stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

192. #### def toStream: Stream[A]

     Converts this stack to a stream.

     Converts this stack to a stream.

     returns

       a stream containing all elements of this stack.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

193. #### def toString(): String

     Converts this stack to a string.

     Converts this stack to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this stack, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       SeqLike → TraversableLike → AnyRef → Any

194. #### def toTraversable: Traversable[A]

     Converts this stack to an unspecified Traversable.

     Converts this stack to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     returns

       a Traversable containing all elements of this stack.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

195. #### def top: A

     Returns the top element of the stack.

     Returns the top element of the stack. This method will not remove the element from the stack. An error is signaled if there is no element on the stack.

     returns

       the top element

     Exceptions thrown
       Predef.NoSuchElementException

196. #### def transform(f: (A) ⇒ A): Stack.this.type

     Applies a transformation function to all values contained in this sequence.

     Applies a transformation function to all values contained in this sequence. The transformation function produces new values from existing elements.

     f

       the transformation to apply

     returns

       the sequence itself.

     Definition Classes
       SeqLike

197. #### def transpose[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): Stack[Stack[B]]

     Transposes this stack of traversable collections into a stack of stacks.

     Transposes this stack of traversable collections into a stack of stacks.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this stack is a `Traversable`.

     returns

       a two-dimensional stack of stacks which has as nth row the nth column of this stack.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this stack are not of the same size.

198. #### abstract def union(that: Seq[A]): Stack[A]

     [use case] Produces a new sequence which contains all elements of this stack and also all elements of a given sequence.

     [use case]

     Produces a new sequence which contains all elements of this stack and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     that

       the sequence to add.

     returns

       a new collection of type `That` which contains all elements of this stack followed by all elements of `that`.

     Definition Classes
       SeqLike

199. #### def union[B >: A, That](that: GenSeq[B])(implicit bf: CanBuildFrom[Stack[A], B, That]): That

     Produces a new sequence which contains all elements of this stack and also all elements of a given sequence.

     Produces a new sequence which contains all elements of this stack and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Another way to express this is that `xs union ys` computes the order-presevring multi-set union of `xs` and `ys`. `union` is hence a counter-part of `diff` and `intersect` which also work on multi-sets.

     B

       the element type of the returned stack.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     that

       the sequence to add.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` which contains all elements of this stack followed by all elements of `that`.

     Definition Classes
       SeqLike → GenSeqLike

200. #### def unzip[A1, A2](implicit asPair: (A) ⇒ (A1, A2)): (Stack[A1], Stack[A2])

     Converts this stack of pairs into two collections of the first and second half of each pair.

     Converts this stack of pairs into two collections of the first and second half of each pair.

     asPair

       an implicit conversion which asserts that the element type of this stack is a pair.

     returns

       a pair stacks, containing the first, respectively second half of each element pair of this stack.

     Definition Classes
       GenericTraversableTemplate

201. #### def unzip3[A1, A2, A3](implicit asTriple: (A) ⇒ (A1, A2, A3)): (Stack[A1], Stack[A2], Stack[A3])

     Converts this stack of triples into three collections of the first, second, and third element of each triple.

     Converts this stack of triples into three collections of the first, second, and third element of each triple.

     asTriple

       an implicit conversion which asserts that the element type of this stack is a triple.

     returns

       a triple stacks, containing the first, second, respectively third member of each element triple of this stack.

     Definition Classes
       GenericTraversableTemplate

202. #### def update(n: Int, newelem: A): Unit

     Replace element at index `n` with the new element `newelem`.

     Replace element at index `n` with the new element `newelem`.

     This is a linear time operation.

     n

       the index of the element to replace.

     newelem

       the new element.

     Definition Classes
       Stack → SeqLike
     Exceptions thrown
       IndexOutOfBoundsException

       if the index is not valid

203. #### abstract def updated(index: Int, elem: A): Stack[A]

     [use case] A copy of this stack with one single replaced element.

     [use case]

     A copy of this stack with one single replaced element.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a new stack`which is a copy of this stack with the element at position` index`replaced by` elem`.`

     Definition Classes
       GenSeqLike

204. #### def updated[B >: A, That](index: Int, elem: B)(implicit bf: CanBuildFrom[Stack[A], B, That]): That

     A copy of this stack with one single replaced element.

     A copy of this stack with one single replaced element.

     B

       the element type of the returned stack.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     index

       the position of the replacement

     elem

       the replacing element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new stack`which is a copy of this stack with the element at position` index`replaced by` elem`.`

     Definition Classes
       SeqLike → GenSeqLike

205. #### def view(from: Int, until: Int): SeqView[A, Stack[A]]

     Creates a non-strict view of a slice of this stack.

     Creates a non-strict view of a slice of this stack.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current stack, whereas `slice` produces a new stack.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this stack, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

206. #### def view: SeqView[A, Stack[A]]

     Creates a non-strict view of this stack.

     Creates a non-strict view of this stack.

     returns

       a non-strict view of this stack.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

207. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

208. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

209. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

210. #### def withFilter(p: (A) ⇒ Boolean): FilterMonadic[A, Stack[A]]

     Creates a non-strict filter of this stack.

     Creates a non-strict filter of this stack.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this stack which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

211. #### abstract def zip[B](that: GenIterable[B]): Stack[(A, B)]

     [use case] Returns a stack formed from this stack and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a stack formed from this stack and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this stack and `that`. The length of the returned collection is the minimum of the lengths of this stack and `that`.

     Definition Classes
       GenIterableLike

212. #### def zip[A1 >: A, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[Stack[A], (A1, B), That]): That

     Returns a stack formed from this stack and another iterable collection by combining corresponding elements in pairs.

     Returns a stack formed from this stack and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     B

       the type of the second half of the returned pairs

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, B)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, B), That]`. is found.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this stack and `that`. The length of the returned collection is the minimum of the lengths of this stack and `that`.

     Definition Classes
       IterableLike → GenIterableLike

213. #### abstract def zipAll[B](that: Iterable[B], thisElem: A, thatElem: B): Stack[(A, B)]

     [use case] Returns a stack formed from this stack and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a stack formed from this stack and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this stack is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this stack.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this stack and `that`. The length of the returned collection is the maximum of the lengths of this stack and `that`. If this stack is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this stack, `thatElem` values are used to pad the result.

     Definition Classes
       GenIterableLike

214. #### def zipAll[B, A1 >: A, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[Stack[A], (A1, B), That]): That

     Returns a stack formed from this stack and another iterable collection by combining corresponding elements in pairs.

     Returns a stack formed from this stack and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this stack is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this stack.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this stack and `that`. The length of the returned collection is the maximum of the lengths of this stack and `that`. If this stack is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this stack, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike

215. #### abstract def zipWithIndex: Stack[(A, Int)]

     [use case] Zips this stack with its indices.

     [use case]

     Zips this stack with its indices.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this stack paired with their index. Indices start at `0`.

     Definition Classes
       GenIterableLike

216. #### def zipWithIndex[A1 >: A, That](implicit bf: CanBuildFrom[Stack[A], (A1, Int), That]): That

     Zips this stack with its indices.

     Zips this stack with its indices.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, Int)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, Int), That]`. is found.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this stack paired with their index. Indices start at `0`.

     Definition Classes
       IterableLike → GenIterableLike

### Deprecated Value Members

1. #### def ++=(xs: TraversableOnce[A]): Stack.this.type

   Annotations
     @deprecated @migration
   Deprecated

     (Since version 2.8.0) use pushAll

   Migration

     (Changed in version 8) 2

2. #### def elements: Iterator[A]

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `iterator' instead`

3. #### def equalsWith[B](that: Seq[B])(f: (A, B) ⇒ Boolean): Boolean

   Tests whether every element of this stack relates to the corresponding element of another sequence by satisfying a test predicate.

   Tests whether every element of this stack relates to the corresponding element of another sequence by satisfying a test predicate.

   B

     the type of the elements of `that`

   that

     the other sequence

   returns

     `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this stack and `y` of `that`, otherwise `false`.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `corresponds` instead

4. #### def findIndexOf(p: (A) ⇒ Boolean): Int

   Returns index of the first element satisfying a predicate, or `-1`.

   Returns index of the first element satisfying a predicate, or `-1`.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) Use indexWhere(p) instead.

5. #### def findLastIndexOf(p: (A) ⇒ Boolean): Int

   Returns index of the last element satisfying a predicate, or -1.

   Returns index of the last element satisfying a predicate, or -1.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `lastIndexWhere` instead

6. #### def first: A

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `head' instead`

7. #### def firstOption: Option[A]

   `None` if iterable is empty.

   `None` if iterable is empty.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `headOption' instead`

8. #### def projection: SeqView[A, Stack[A]]

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   Definition Classes
     SeqLike → IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `view' instead`

9. #### def reversedElements: Iterator[A]

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `reverseIterator' instead`

### Inherited from Serializable

### Inherited from Seq[A]

### Inherited from SeqLike[A, Stack[A]]

### Inherited from Cloneable[Stack[A]]

### Inherited from Seq[A]

### Inherited from SeqLike[A, Stack[A]]

### Inherited from GenSeq[A]

### Inherited from GenSeqLike[A, Stack[A]]

### Inherited from PartialFunction[Int, A]

### Inherited from (Int) ⇒ A

### Inherited from Iterable[A]

### Inherited from IterableLike[A, Stack[A]]

### Inherited from Equals

### Inherited from GenIterable[A]

### Inherited from GenIterableLike[A, Stack[A]]

### Inherited from Traversable[A]

### Inherited from Mutable

### Inherited from Traversable[A]

### Inherited from GenTraversable[A]

### Inherited from GenericTraversableTemplate[A, Stack]

### Inherited from TraversableLike[A, Stack[A]]

### Inherited from GenTraversableLike[A, Stack[A]]

### Inherited from Parallelizable[A, ParSeq[A]]

### Inherited from TraversableOnce[A]

### Inherited from GenTraversableOnce[A]

### Inherited from FilterMonadic[A, Stack[A]]

### Inherited from HasNewBuilder[A, Stack[A]]

### Inherited from AnyRef

### Inherited from Any